package xyz.ottr.lutra.revottr.evaluation;

/*-
 * #%L
 * xyz.ottr.lutra:lutra-revottr
 * %%
 * Copyright (C) 2018 - 2023 University of Oslo
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-2.1.html>.
 * #L%
 */

import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import xyz.ottr.lutra.model.Argument;
import xyz.ottr.lutra.model.Parameter;
import xyz.ottr.lutra.model.terms.NoneTerm;
import xyz.ottr.lutra.model.terms.Term;
import xyz.ottr.lutra.revottr.model.Mapping;
import xyz.ottr.lutra.revottr.model.Mappings;
import xyz.ottr.lutra.revottr.model.PartialOrder;
import xyz.ottr.lutra.revottr.model.terms.Placeholder;
import xyz.ottr.lutra.revottr.model.terms.RListTerm;

/**
 * Implements the reverse of OTTR list expansion. Note: The number of solutions generated
 * by reverse list expansion quickly grows to computationally unfeasible numbers. This is
 * only implemented for demonstration purposes.
 * <p>
 * In forward OTTR, an instance with an expansion mode will expand to multiple instances.
 * Each produced instance correspond to some combination of the elements in the lists of
 * the original instance. Therefore, in reverse, multiple instances should be combined to
 * a single instance. The resulting instance should have lists such that expanding them
 * in forward OTTR, with the given expansion mode, reproduces the input instances. Note
 * that this implementation represent instances as mappings. Therefore, the input and
 * output are sets of mappings, rather than instances.
 * <p>
 * Repetitions in lists that are subjected to list expansion sometimes expand to multiple
 * of the same instance and are thus ignored in forward OTTR. Therefore, in reverse, we
 * cannot know how many times elements should be repeated. We control the maximum number
 * of repetitions in generated lists with the class attribute maxRepetitions.
 * <p>
 * Similarly to repetitions, we cannot know which order lists should have, so we simply
 * generate lists of all possible orders.
 */
public class ListUnexpander {

    /**
     * Parameter variables of the instantiated template that are marked
     * for list expansion.
     */
    private final List<Term> markedVariables;

    /**
     * Parameter variables of the instantiated template that are not marked
     * for list expansion.
     */
    private final List<Term> unmarkedVariables;

    /**
     * The set of mappings that's always generated by unzipMin and uncross.
     * Each mapping in this set has an empty list such that expanding it
     * with zipMin or cross in forward OTTR would produce an empty set of
     * instances.
     */
    private final Set<Mapping> minEmpty;

    /**
     * Similarly to minEmpty, a set of mappings with empty lists such that
     * expanding it in forward OTTR with zipMax would produce an empty set
     * of instances.
     */
    private final Set<Mapping> maxEmpty;

    /**
     * Maximum number of repetitions in lists generated by reverse list expansion.
     */
    private final int maxRepetitions;

    /**
     * Creates a ListUnexpander for computing the reverse of OTTR list expansion.
     *
     * @param parameters Parameters of instantiated template
     * @param arguments Arguments of instance
     * @param repetitions Maximum number of repetitions in generated lists
     */
    public ListUnexpander(List<Parameter> parameters, List<Argument> arguments, int repetitions) {
        this.markedVariables = getMarkedVars(parameters, arguments);
        this.unmarkedVariables = getUnmarkedVars(parameters, arguments);
        this.minEmpty = minUnfltr();
        this.maxEmpty = maxUnfltr();
        this.maxRepetitions = repetitions;
    }

    /**
     * The reverse of OTTR cross.
     *
     * @param mappings A set of mappings that is the result of evaluating a template as a query.
     * @return A set of mappings that could be expanded with cross in OTTR to produce the
     * input-set of mappings.
     */
    public Set<Mapping> uncross(Set<Mapping> mappings) {
        Set<Set<Mapping>> compSets = findCompatibleSets(mappings);

        Set<Mapping> result = new HashSet<>();

        for (Set<Mapping> compSet : compSets) {
            Set<Mapping> uncrossed = toMappings(compactifyAll(compSet));

            // Note: non-null by definition of compSet
            Mapping glbMapping = glbset(compSet);

            for (Mapping mapping : uncrossed) {
                for (Mapping mapPermutation : mapPermutations(mapping)) {
                    Mapping resultMap = Mappings.union(glbMapping, mapPermutation);
                    result.add(resultMap);
                }
            }
        }

        result.addAll(this.minEmpty);
        return result;
    }

    /**
     * Generate all possible orderings and sublists for the uncrossed lists in a mapping.
     */
    private Set<Mapping> mapPermutations(Mapping mapping) {
        Set<Set<Mapping>> tempSet = new HashSet<>();

        for (Term var : mapping.domain()) {
            Set<Mapping> varSet = new HashSet<>();

            List<Term> list = ((RListTerm) mapping.get(var)).asList();

            for (var sublist : sublists(list)) {
                for (var repeated : repeat(sublist)) {
                    for (var order : permutations(repeated.size())) {
                        Mapping m = new Mapping();
                        RListTerm term = new RListTerm(applyOrder(order, repeated));
                        m.put(var, term);
                        varSet.add(m);
                    }
                }
            }

            tempSet.add(varSet);
        }

        return Mappings.joinAll(tempSet);
    }

    /**
     * Finds a set of sublists of the input lists. The sublists are the same order
     * as the input list, up to the last element of the sublist.
     */
    private <T> Set<List<T>> sublists(List<T> list) {
        Set<List<T>> result = new HashSet<>();
        List<T> resultList = new LinkedList<>();
        for (var t : list) {
            resultList.add(t);
            result.add(resultList);
            resultList = new LinkedList<>(resultList);
        }

        return result;
    }

    /**
     * Converts the Map objects (with sets of terms) used in uncross
     * into Mapping objects (with RListTerms instead of sets).
     */
    private Set<Mapping> toMappings(Set<Map<Term, Set<Term>>> set) {
        Set<Mapping> result = new HashSet<>();
        for (Map<Term, Set<Term>> map : set) {
            Mapping mapping = new Mapping();
            for (Map.Entry<Term, Set<Term>> entry : map.entrySet()) {
                List<Term> termList = new LinkedList<>(entry.getValue());
                mapping.put(entry.getKey(), new RListTerm(termList));
                result.add(mapping);
            }
        }

        return result;
    }

    /**
     * The main function of uncross, where elements of possible lists in the solution
     * are determined.
     */
    private Set<Map<Term, Set<Term>>> compactifyAll(Set<Mapping> mappings) {
        Set<Map<Term, Set<Term>>> compacted = uncrossMin(mappings);
        Set<Map<Term, Set<Term>>> nextCompacted = new HashSet<>();

        for (Term markedVar : markedVariables) {
            for (var m1 : compacted) {
                Map<Term, Set<Term>> map = m1;
                for (var m2 : compacted) {
                    Map<Term, Set<Term>> temp = compactify(map, m2, markedVar);
                    if (temp != null) {
                        map = temp;
                    }
                }
                nextCompacted.add(map);
            }
            compacted = nextCompacted;
            nextCompacted = new HashSet<>();
        }

        return compacted;
    }

    /**
     * Combines two mappings that are potential solutions to uncross to create another potential solution.
     * This method is based on idea that two mappings from terms to sets of terms, that represents solutions
     * to uncross, with the same domain i.e. terms that represent variables, can be combined by the union of
     * one variable and the disjunction of the other variables in their domain.
     */
    private Map<Term, Set<Term>> compactify(Map<Term, Set<Term>> m1, Map<Term, Set<Term>> m2, Term var) {
        Map<Term, Set<Term>> combination = new HashMap<>();
        combination.put(var, union(m1.get(var), m2.get(var)));
        for (Term otherVar : markedVariables) {
            if (!otherVar.equals(var)) {
                combination.put(otherVar, intersection(m1.get(otherVar), m2.get(otherVar)));
            }
        }

        if (hasEmptySet(combination)) {
            return null;
        }

        return combination;
    }

    private boolean hasEmptySet(Map<Term, Set<Term>> map) {
        for (Map.Entry<Term, Set<Term>> entry : map.entrySet()) {
            if (entry.getValue().isEmpty()) {
                return true;
            }
        }
        return false;
    }

    private Set<Term> intersection(Set<Term> s1, Set<Term> s2) {
        Set<Term> result = new HashSet<>();
        for (Term t1 : s1) {
            for (Term t2 : s2) {
                Term glb = PartialOrder.getGLB(t1, t2);
                if (glb != null) {
                    result.add(glb);
                }
            }
        }
        return result;
    }

    private Set<Term> union(Set<Term> s1, Set<Term> s2) {
        Set<Term> result = new HashSet<>();

        for (Term t1 : s1) {
            for (Term t2 : s2) {
                Term glb = PartialOrder.getGLB(t1, t2);
                if (glb != null) {
                    result.add(glb);
                } else {
                    result.add(t1);
                    result.add(t2);
                }
            }
        }

        return result;
    }

    /**
     * The smallest mappings that represents solutions to uncross.
     */
    private Set<Map<Term, Set<Term>>> uncrossMin(Set<Mapping> mappings) {
        Set<Map<Term, Set<Term>>> result = new HashSet<>();
        for (Mapping mapping : mappings) {
            Map<Term, Set<Term>> uncrossed = new HashMap<>();
            for (Term var : markedVariables) {
                Set<Term> set = new HashSet<>();
                set.add(mapping.get(var));
                uncrossed.put(var, set);
            }
            result.add(uncrossed);
        }

        return result;
    }

    /**
     * The reverse of zipMin in OTTR. Generates mappings from the input set such that
     * applying zipMin to the result re-obtains the input set.
     * Since zipMin ignores elements in lists past the index of the last element of the
     * shortest list, unzipMin appends the placeholder PartialOrder.any_trail, to signify
     * that the remaining elements of lists other than the shortest could be anything.
     *
     * @param mappings A set of mappings, presumably obtained from the evaluateTemplate-method
     *                 in the Evaluator-class.
     * @return A set of mappings that could be zipMined to produce the input-set.
     */
    public Set<Mapping> unzipMin(Set<Mapping> mappings) {
        Set<Mapping> result = unzip(mappings).stream()
                .map(this::addTrail)
                .reduce(Util::setUnion).orElse(new HashSet<>());

        result.addAll(minEmpty);
        return result;
    }

    /**
     * Helper method for unzipMin. In forward OTTR, zipMin combines the elements
     * of lists pairwise, by index, up to the length of the shortest list, ignoring the rest.
     * Then, in reverse, it's unknowable what elements should come after the length of the
     * shortest list. We signify this by appending a special placeholder at the end of
     * every list generated by unzip, except for one.
     */
    private Set<Mapping> addTrail(Mapping mapping) {
        Set<Mapping> result = new HashSet<>();
        List<Term> unmarkedTerms = mapping.get(unmarkedVariables);

        for (Term pick : markedVariables) {
            Mapping alternative = new Mapping(unmarkedVariables, unmarkedTerms);
            alternative.put(pick, mapping.get(pick));

            for (Term var : markedVariables) {
                if (!pick.equals(var)) {
                    List<Term> termList = new LinkedList<>(((RListTerm)mapping.get(var)).asList());
                    termList.add(Placeholder.any_trail);
                    alternative.put(var, new RListTerm(termList));
                }
            }
            result.add(alternative);
        }

        return result;
    }

    /**
     * The reverse of zipMax in OTTR.
     *
     * @param mappings A set of mappings that were obtained from evaluating a template as a query.
     * @return A set of mappings that could be zipMaxed to produce the input-set.
     */
    public Set<Mapping> unzipMax(Set<Mapping> mappings) {
        Set<Mapping> result = unzip(mappings).stream()
                .map(this::noneTrailAlternatives)
                .reduce(Util::setUnion).orElse(new HashSet<>());

        result.addAll(maxEmpty);
        return result;
    }

    /**
     * One or more trailing NoneTerms may be removed from lists generated by unzipMax
     * to produce alternative solutions. This method finds all such alternatives for a
     * given mapping.
     */
    private Set<Mapping> noneTrailAlternatives(Mapping mapping) {
        Set<Set<Mapping>> alternatives = new HashSet<>();
        for (Term var : markedVariables) {
            alternatives.add(noneTrailLists(mapping, var));
        }

        Set<Mapping> partialAlternatives = Mappings.joinAll(alternatives);
        for (Mapping partialAlternative : partialAlternatives) {
            partialAlternative.put(unmarkedVariables, mapping.get(unmarkedVariables));
        }

        return partialAlternatives;
    }

    private Set<Mapping> noneTrailLists(Mapping mapping, Term var) {
        RListTerm originalListTerm = (RListTerm) mapping.get(var);
        Set<Mapping> result = new HashSet<>();
        result.add(new Mapping(var, originalListTerm));

        List<Term> originalList = originalListTerm.asList();
        int i = originalList.size() - 1;
        while (i >= 0 && originalList.get(i) instanceof NoneTerm) {
            List<Term> altList = new LinkedList<>(originalList.subList(0, i));
            RListTerm altListTerm = new RListTerm(altList);
            result.add(new Mapping(var, altListTerm));
            i--;
        }

        return result;
    }

    private <T> List<T> applyOrder(List<Integer> order, List<T> list) {
        return order.stream().map(list::get).collect(Collectors.toList());
    }

    private Set<List<Integer>> permutations(int size) {

        if (size == 1) {
            return Set.of(List.of(0));
        }

        Set<List<Integer>> result = new HashSet<>();
        for (List<Integer> list : permutations(size - 1)) {
            for (int i = 0; i <= list.size(); i++) {
                List<Integer> newList = new LinkedList<>(list);
                newList.add(i, size - 1);
                result.add(newList);
            }
        }

        return result;
    }

    /**
     * Generates mappings with lists common to unzipMin and unzipMax.
     *
     * It finds the mappings with lists such that when either of zipMin or zipMax
     * is applied, the input-set of mappings is re-obtained. These mappings must
     * be compatible over the unmarked variables.
     *
     * Additionally, it generates all possible orders of such lists, because order
     * doesn't affect the result of zipMin or zipMax in forward OTTR.
     */
    private Set<Mapping> unzip(Set<Mapping> mappings) {
        Set<Mapping> result = new HashSet<>();

        for (Set<Mapping> compSet : findCompatibleSets(mappings)) {
            for (List<Mapping> repeated : repeat(new LinkedList<>(compSet))) {
                for (List<Integer> order : permutations(repeated.size())) {
                    result.add(unzipList(applyOrder(order, repeated)));
                }
            }
        }

        return result;
    }

    /**
     * Given a list of unique elements without repetitions, returns a set of all lists
     * where the number of repetitions of each element in the input list are less or
     * equal to the maxRepetitions class attribute, ignoring order.
     */
    private <T> Set<List<T>> repeat(List<T> list) {
        Set<List<T>> result = new HashSet<>();
        result.add(list);

        for (T t : list) {
            for (int i = 0; i < this.maxRepetitions; i++) {
                Set<List<T>> temp = new HashSet<>();
                for (List<T> resultList : result) {
                    List<T> other = new LinkedList<>(resultList);
                    other.add(t);
                    temp.add(other);
                }
                result.addAll(temp);
            }
        }

        return result;
    }

    /**
     * Unzips in the order of the input list of mappings
     */
    private Mapping unzipList(List<Mapping> mappings) {
        Map<Term, List<Term>> unzipMap = new HashMap<>();

        for (Term var : markedVariables) {
            unzipMap.put(var, new LinkedList<>());
        }

        for (Mapping mapping : mappings) {
            for (Term var : markedVariables) {
                unzipMap.get(var).add(mapping.get(var));
            }
        }

        Mapping result = glbset(new HashSet<>(mappings));

        for (Term var : markedVariables) {
            RListTerm listTerm = new RListTerm(unzipMap.get(var));
            result.put(var, listTerm);
        }

        return result;
    }

    /**
     * Given a set of mappings, finds all subsets where all mappings are compatible
     * for the template variables that aren't marked for list expansion.
     */
    private Set<Set<Mapping>> findCompatibleSets(Set<Mapping> mappings) {
        Set<Set<Mapping>> result = new HashSet<>();

        for (Mapping mapping : mappings) {
            Set<Mapping> compSet = new HashSet<>();
            compSet.add(mapping);
            result.add(compSet);
        }

        for (Mapping mapping : mappings) {
            Set<Set<Mapping>> workSet = new HashSet<>();
            for (Set<Mapping> compSet : result) {
                Mapping glb = glbset(compSet);
                if (glb != null && Mappings.compatible(glb, mapping)) {
                    Set<Mapping> fresh = new HashSet<>(compSet);
                    fresh.add(mapping);
                    workSet.add(fresh);
                }
            }

            result.addAll(workSet);
        }

        return result;
    }

    /**
     * Finds the greatest mapping with the set of variables that are not marked
     * for list expansion as its domain, that is compatible with every mapping
     * in the given set.
     */
    private Mapping glbset(Set<Mapping> mappings) {
        Mapping result = new Mapping();
        for (Term var : unmarkedVariables) {
            result.put(var, Placeholder.any);
        }

        for (Mapping mapping : mappings) {
            result = glbmapping(result, mapping);
            if (result == null) {
                return null;
            }
        }

        return result;
    }

    private Mapping glbmapping(Mapping m1, Mapping m2) {
        Mapping result = new Mapping();
        for (Term var : unmarkedVariables) {
            Term glb = PartialOrder.getGLB(m1.get(var), m2.get(var));
            if (glb != null) {
                result.put(var, glb);
            } else {
                return null;
            }
        }

        return result;
    }

    private List<Term> getMarkedVars(List<Parameter> parameters, List<Argument> arguments) {
        List<Term> result = new LinkedList<>();

        for (int i = 0; i < parameters.size(); i++) {
            if (arguments.get(i).isListExpander()) {
                result.add(parameters.get(i).getTerm());
            }
        }

        return result;
    }

    private List<Term> getUnmarkedVars(List<Parameter> parameters, List<Argument> arguments) {
        List<Term> result = new LinkedList<>();

        for (int i = 0; i < parameters.size(); i++) {
            if (!arguments.get(i).isListExpander()) {
                result.add(parameters.get(i).getTerm());
            }
        }

        return result;
    }

    /**
     * Generates mappings that would produce an empty graph when expanded as
     * instances with zipMin or cross in forward OTTR, for these marked variables.
     */
    private Set<Mapping> minUnfltr() {
        Set<Mapping> result = new HashSet<>();

        for (Term marked : this.markedVariables) {
            Mapping mapping = new Mapping();
            mapping.put(marked, new RListTerm(new LinkedList<>()));
            for (Term other : this.markedVariables) {
                if (!other.equals(marked)) {
                    List<Term> list = new LinkedList<>();
                    list.add(Placeholder.any_trail);
                    mapping.put(other, new RListTerm(list));
                }
            }

            for (Term unmarked : this.unmarkedVariables) {
                mapping.put(unmarked, Placeholder.any);
            }

            result.add(mapping);
        }

        return result;
    }

    /**
     * Generates the mapping that would produce an empty graph when expanded
     * as an instance with zipMax in forward OTTR, for these marked variables.
     */
    private Set<Mapping> maxUnfltr() {
        Mapping mapping = new Mapping();

        for (Term unmarked : this.unmarkedVariables) {
            mapping.put(unmarked, Placeholder.any);
        }

        for (Term marked : this.markedVariables) {
            mapping.put(marked, new RListTerm(new LinkedList<>()));
        }

        return Set.of(mapping);
    }
}
